<template>
  <div v-click-outside="hideDropdown" class="wrapper">
    <label :for="id" class="base-label">
      {{ label }}
    </label>
    <div
      :class="['base-input-wrapper', {'base-input-wrapper_focused': focused || isDropdownOpen}]"
    >
      <img class='curent-country' :src='require(`../../assets/img/countries/${selectedListItem.img}.svg`)' alt='country' width='24' height='24' />
      <input
        :id="id"
        v-model="searchValue"
        class="base-input"
        v-bind="$attrs"
        :placeholder="$attrs.placeholder"
        readonly
        @focus="focusHandler"
        @input="inputHandler"
        @blur="blurHandler"
      >
    </div>
    <div
      v-show="isDropdownOpen"
      class="list-selector___dropdown"
    >
      <ul>
        <li
          v-for="item in unselectedItems"
          :key="item.id"
          @click="onItemClick(item)"
        >
          <img :src='require(`../../assets/img/countries/${item.img}.svg`)' alt='country' width='24' height='24' />
          {{ item[itemKey] }}
        </li>
        <li v-show="!filteredList.length" class="empty">
          Ничего не найдено
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import ClickOutside from 'vue-click-outside'

export default {

  directives: {
    ClickOutside
  },
  props: {
    value: {
      type: [String, Number],
      default: ''
    },

    id: {
      type: String,
      default: ''
    },

    label: {
      type: String,
      default: ''
    },

    list: {
      type: Array
    },

    itemKey: {
      type: String
    },

    defaultValue: {
      type: Object
    }
  },

  data () {
    return {
      focused: false,
      isDropdownOpen: false,
      selectedListItem: {},
      filteredList: this.list,
      searchValue: '',
    }
  },

  computed: {
    unselectedItems() {
      return this.list.filter(item => item.id !== this.selectedListItem.id)
    }
  },

  watch: {
    selectedListItem () {
      this.$emit('selected', this.selectedListItem)
    }
  },

  created() {
    if(this.defaultValue) {
      this.searchValue = this.defaultValue[this.itemKey]
      this.selectedListItem = this.defaultValue
    }
  },

  methods: {
    inputHandler () {
      this.isDropdownOpen = true
    },

    focusHandler () {
      this.focused = true
      this.isDropdownOpen = true
    },

    blurHandler () {
      this.focused = false
    },

    hideDropdown () {
      this.isDropdownOpen = false
    },

    onItemClick (item) {
      this.selectedListItem = item
      this.searchValue = item[this.itemKey]
      this.isDropdownOpen = false
    },

    getSearchItem () {
      this.filteredList = this.list.filter(item => item[this.itemKey].toLowerCase().includes(this.searchValue.toLowerCase()))
    }
  }
}
</script>

<style scoped lang="scss">

.wrapper {
  position: relative;
  z-index: 1;
}

.base-input-wrapper {
  background: transparent;
  border: 1px solid transparent;
  padding: 2px 0;
  width: 100%;
  position: relative;

  &::before {
    content: '';
    position: absolute;
    background-repeat: no-repeat;
    background-image: url("../../assets/img/vector.svg");
    background-position: center;
    width: 11px;
    height: 8px;
    right: 0;
    top: 50%;
    transform: translateY(-50%);
  }
}

.base-input {
  width: 44px;
  height: 24px;
  margin: 0;
  border: none;
  outline: none;
  padding: 0 20px 0 0 ;
  background-color: transparent;
  font-size: 0;
  cursor: pointer;
  color: transparent;

  &::placeholder {
    color: white;
  }
}

.base-label {
  color: white;
  font-size: 18px;
  display: none;
}

.list-selector___dropdown {
  max-height: 100px;
  min-width: 80px;
  position: absolute;
  z-index: 4;
  margin-top: 4px;
  margin-left: -6px;

  ul {
    list-style: none;
    margin: 0;
    padding: 0;
    font-size: 16px;
    line-height: 24px;
    background: #0E1B4E;
    border: 2px solid #3A4675;
    border-radius: 4px;

  }
  li {
    font-weight: 400;
    font-size: 16px;
    line-height: 16px;
    padding: 7px 5px;
    cursor: pointer;
    color: white;
    display: flex;
    align-items: center;

    &:hover {
      background: #ffffff1A;
    }
  }

  img {
    margin-right: 8px;
  }
}
.empty {
  text-align: center;
  font-size: 12px;
}

li.empty:hover {
  background-color: transparent;
}

.curent-country {
  position: absolute;
  left: 0;
  top: 5px;
  pointer-events: none;
}

</style>
